<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty pre modifier plugin
 *
 * Type:     modifier<br>
 * Name:     pre<br>
 * Purpose:  show text as <pre> [...]
 * @link
 * @author   José Carlos Cruz Parra AKA Internia
 * @param string $string
 * @param string $length
 * @return string
 */
function smarty_modifier_pre($string,$length=0)
{
    if($length > 0)
    {
    	$string = wordwrap($string, $length);
    }
	$string = str_replace(" ", "&nbsp;", $string);
    $string = str_replace("\n", "<br />", $string);
    $string = str_replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;", $string);
    return $string;
}

/* vim: set expandtab: */

?>
