<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2017-05-05
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/kapitaltruth/admin/grupos/functions.inc.php
 *
 */

/**
 * Valida los datos de un registro de un grupo
 *
 * @param array $data
 * @return bool
 */
function kapitaltruth_grupos_validarDatos($data)
{
    global $swphp_idiomas;

	$ok = true;

	$requeridos = array(
		'texto'=>l('Nombre', 'kapitaltruth'),
		);

	foreach($requeridos as $key=>$nombre)
	{
		if(!isset($data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key]) || $data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key] == '')
		{
			SWPHP::_Msg(l('Falta el dato:', 'kapitaltruth')." {$nombre} ({$swphp_idiomas[SWPHP_IDIOMA_POR_DEFECTO]['nombre']})", "error");
			$ok = false;
		}
	}

	return $ok;
}
/**
 * Prepara los datos para insertar o actualizar un grupo en la base de datos
 *
 * @param array $data
 * @param int $id
 * @return array
 */
function kapitaltruth_grupos_prepararDatos($data, $id=0)
{
	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case 'activo':
				$data[$key] = $value ? '1' : '0';
				break;
			default:
				//Cualquier otro dato lo descarto
				unset($data[$key]);
				break;
		}
	}

	return $data;
}
/**
 * Elimina un grupo
 *
 * @param int $id
 */
function kapitaltruth_grupos_eliminarGrupo($id)
{
	global $db;

	if($db->Execute("DELETE FROM ".SWPHP_DBPREFIX."kptl_grupos WHERE id = '{$id}'"))
	{
        $db->Execute("DELETE FROM ".SWPHP_DBPREFIX."kptl_grupos_idiomas WHERE grupo_id = '{$id}'");

		return true;
	}

	return false;
}
/**
 * Prepara los datos para insertar o actualizar datos de un grupo en idioma
 *
 * @param array $idiomas
 * @param int $idioma_id
 * @param int $id
 * @return array
 */
function kapitaltruth_grupos_prepararDatosIdioma($idiomas, $idioma_id, $id=0)
{
	$data = SWPHP::_PrepararDatosIdioma($idiomas, $idioma_id, array('texto'));

	if($id)
	{
		$data['grupo_id'] = $id;
	}
	$data['idioma_id'] = $idioma_id;

	return $data;
}
