<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-04-20
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/kapitaltruth/inc/xajax/valoraciones.xajax.php
 *
 */

function CargarValoracion($user_idpasivo)
{
	global $db, $kptl_user_id;

	$response = new xajaxResponse();

	ob_start();

	$user_idpasivo = intval($user_idpasivo);
	$user = new KPTL_User($user_idpasivo);

	if($kptl_user_id > 0 && $user_idpasivo > 0 && $kptl_user_id != $user_idpasivo && $user->Exists())
	{
		$html = KPTL::GetFormEscala($user_idpasivo, null, "GuardarValoracion({$user_idpasivo}); return false;");

		$response->assign('span_nick', 'innerHTML', $user->GetValue('nick'));
		$response->assign('span_nombre', 'innerHTML', $user->GetValue('nombre'));
		$response->assign('div_valoracion_content', 'innerHTML', $html);
		$response->script("stripeByClass('listado')");
	}
	else
	{
		$response->assign('div_valoracion_content', 'innerHTML', l('Error', 'kapitaltruth'));
	}

	$str = ob_get_clean();
	if($str)
	{
		$response->alert(strip_tags($str));
	}

	return $response;
}
$xajax->registerFunction('CargarValoracion');

function GuardarValoracion($user_idpasivo, $data, $g)
{
	global $db, $kptl_user;

	$response = new xajaxResponse();

	ob_start();

	$user_idpasivo = intval($user_idpasivo);
	$user = new KPTL_User($user_idpasivo);

	if($user_idpasivo > 0 && $user->Exists() && is_array($data) && sizeof($data) > 0)
	{
		$hoy = date('Y-m-d');

		$valoracion_id = $kptl_user->GetValoracionId($user_idpasivo, $hoy, true);
		$autovaloracion = $user->GetAutoValoracion();
		$puntostotal = 0;
		$c = 0;

		foreach($data as $item)
		{
			if(is_array($item) && sizeof($item) == 2)
			{
				if(substr($item[0], 0, 10) == 'preguntas[')
				{
					$c++;
					$pregunta_id = intval(substr($item[0], 10, strlen($item[0])-11));
					$pregunta = new KPTL_Pregunta($pregunta_id);
					$respuestas = $pregunta->GetRespuestas();
					$respuesta_id = intval($item[1]);

					if(isset($autovaloracion[$pregunta_id]) && $autovaloracion[$pregunta_id] > 0 && isset($respuestas[$respuesta_id]))
					{
						if($respuestas[$respuesta_id]['propia'])
						{
							if($autovaloracion[$pregunta_id] == $respuesta_id)
							{
								$puntos = $respuestas[$respuesta_id]['puntos'];
							}
							elseif($respuestas[$autovaloracion[$pregunta_id]]['puntos'] == 0)
							{
								$puntos = $respuestas[$respuesta_id]['puntosmodestia'];
							}
							else
							{
								$puntos = 0;
							}
						}
						else
						{
							if($autovaloracion[$pregunta_id] == $respuestas[$respuesta_id]['ref_id'])
							{
								$puntos = $respuestas[$respuesta_id]['puntos'];
							}
							elseif($respuestas[$autovaloracion[$pregunta_id]]['puntos'] == 0)
							{
								$puntos = $respuestas[$respuesta_id]['puntosmodestia'];
							}
							else
							{
								$puntos = 0;
							}
						}
					}
					else
					{
						$puntos = 0;
					}

					//debugging
					//$response->alert("{$autovaloracion[$pregunta_id]} - {$respuesta_id} - {$puntos}");

					$puntostotal += $puntos;

					if($db->Exists(array($valoracion_id, $pregunta_id), array('valoracion_id', 'pregunta_id'), SWPHP_DBPREFIX.'kptl_valoraciones_preguntas'))
					{
						$query = buildQuery_Update(array('respuesta_id'=>$respuesta_id, 'puntos'=>$puntos), SWPHP_DBPREFIX.'kptl_valoraciones_preguntas', array('valoracion_id'=>$valoracion_id, 'pregunta_id'=>$pregunta_id));
					}
					else
					{
						$query = buildQuery_Insert(array('valoracion_id'=>$valoracion_id, 'pregunta_id'=>$pregunta_id, 'respuesta_id'=>$respuesta_id, 'puntos'=>$puntos), SWPHP_DBPREFIX.'kptl_valoraciones_preguntas');
					}

					SWPHP::_ExecuteQuery(
						$query,
						'',
						l('No se ha podido guardar tu respuesta a la pregunta número', 'kapitaltruth').' '.$c
						);
				}
			}
		}

		//Actualizar puntos totales en tabla valoraciones
		SWPHP::_ExecuteQuery(
			buildQuery_Update(array('puntos'=>$puntostotal), SWPHP_DBPREFIX.'kptl_valoraciones', $valoracion_id),
			'',
			l('No se ha podido actualizar el total de la valoración', 'kapitaltruth').' '.$c
			);

		$response->script("popupValoracion.hide()");

		//Actualizar listado y contadores conjuntos si es la primera vez que el usuario valora al otro usuario
		if($g == 'nunca')
		{
			$response->assign('span_antes', 'innerHTML', $kptl_user->GetConjuntoAntes(true));
			$response->assign('span_nunca', 'innerHTML', $total = $kptl_user->GetConjuntoNunca(true));
			$response->assign('pag_total_valoraciones', 'innerHTML', intval($total));
			$response->script("gebi('a_valorar{$user_idpasivo}').parentNode.parentNode.style.display = 'none';");
		}
	}
	else
	{
		$response->assign('div_valoracion_content', 'innerHTML', l('Error', 'kapitaltruth'));
	}

	$str = ob_get_clean();
	if($str)
	{
		$response->alert(strip_tags($str));
	}

	$response = SWPHP_Xajax::_VolcarMensajes($response, true);

	return $response;
}
$xajax->registerFunction('GuardarValoracion');
?>