<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-12-25
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/modulos/install.php
 *
 */

/**
 * Realiza las actuaciones particulares de la instalación de este módulo:
 *
 * @param array $info
 * @return bool
 */
function modulos_instalar($info)
{
	global $db;

	$ok = true;

	SWPHP::_ExecuteQuery("SET NAMES 'utf8'", "", "");

	$queries = array(
		"CREATE TABLE IF NOT EXISTS `".SWPHP_DBPREFIX."modulos` (
		  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
		  `clave` varchar(60) NOT NULL,
		  `titulo` varchar(60) NOT NULL,
		  `descripcion` varchar(255) NOT NULL,
		  `activo` tinyint(3) unsigned NOT NULL DEFAULT '1',
		  `icono` varchar(60) NOT NULL,
		  `core` tinyint(3) unsigned NOT NULL DEFAULT '0',
		  `fechayhoraregistro` datetime NOT NULL,
		  `fechayhoraultima` datetime NOT NULL,
		  `user_idregistro` int(10) unsigned NOT NULL DEFAULT '0',
		  `user_idultima` int(10) unsigned NOT NULL DEFAULT '0',
		  `version` varchar(10) NOT NULL,
		  PRIMARY KEY (`id`),
		  UNIQUE KEY `clave` (`clave`)
		) DEFAULT CHARSET=utf8",
		"CREATE TABLE IF NOT EXISTS `".SWPHP_DBPREFIX."modulos_perfiles` (
		  `modulo_id` int(10) unsigned NOT NULL,
		  `perfil_id` smallint(5) unsigned NOT NULL,
		  `permiso_id` enum('0','1','2','3') NOT NULL DEFAULT '0',
		  PRIMARY KEY (`modulo_id`,`perfil_id`)
		) DEFAULT CHARSET=utf8",
		);
	foreach($queries as $query)
	{
		$ok &= SWPHP::_ExecuteQuery($query, "", "No se pudo ejecutar la sentencia:<br /> {$query}");
	}

	return $ok;
}
/**
 * Realiza las actuaciones particulares de la desinstalación de este módulo
 *
 * @param array $info
 * @return bool
 */
function modulos_desinstalar($info)
{
	//Es un módulo core

	return false;
}