<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-03-18
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 *  inc/modules/multimedia/functions.inc.php
 */

/**
 * Transforma la ruta para utilizar la página del módulo en vez de multimedia/
 *
 * @param string $ruta
 * @return string
 */
function multimedia_ruta2paginaActual($ruta)
{
	return substr($ruta, 0, 11) == 'multimedia/' ? SWPHP_PAGINA_ACTUAL.substr($ruta, 11) : $ruta;
}
/**
 * Obtiene la imagen en miniatura correspondiente un archivo multimedia
 *
 * @param string $dir
 * @param string $file
 * @param string $extsP
 * @param string $thumbsWidthP
 * @param string $thumbsHeightP
 * @return string
 */
function multimedia_getThumb($dir, $file, $extsP=null, $thumbsWidthP=null, $thumbsHeightP=null)
{
	global $exts, $thumbsWidth, $thumbsHeight;

	if(!is_null($extsP)) $exts = $extsP;
	if(!is_null($thumbsWidthP)) $thumbsWidth = $thumbsWidthP;
	if(!is_null($thumbsHeightP)) $thumbsHeight = $thumbsHeightP;

	$thumb = 'nothumb';
	$filepath = $dir.$file;

	$ext = GetExtension($file, false);
	$lowerext = strtolower($ext);

	switch($lowerext)
	{
		default:
		case 'jpg':
			if(is_file($filepath))
			{
				$thumb = "{$dir}thumbs/{$file}";
				if(!is_file($thumb))
				{
					if(in_array($lowerext, $exts['imagen']))
					{
						resizeImage($filepath, array($thumbsWidth, $thumbsHeight), "{$dir}thumbs/");
					}
				}
			}
			break;
		case 'flv':
			if(is_file($filepath))
			{
				$file = str_replace('.flv', '.jpg', $file);

				$thumb = "{$dir}thumbs/{$file}";
				if(!is_file($thumb))
				{
					//TODO: crear thumbs de videos
					$thumb = 'nothumb';
				}
			}
			break;
		case 'mp3':
			//Para los archivos de audo los thumbs no tienen sentido por ahora (por el player)
			if(is_file($filepath))
			{
				$file = str_replace('.mp3', '.jpg', $file);

				$thumb = "{$dir}thumbs/{$file}";
				if(!is_file($thumb))
				{
					//TODO: crear thumbs de audio?
					$thumb = 'nothumb';
				}
			}
			break;
	}

	return is_file($thumb) ? $thumb : SWPHP_THEME_DIR."img/multimedia/nothumb.png";
}
?>