<?php
/**
 * Armando Servillera Torres
 * www.pagina-web-barata.com
 * 2011-09-14
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/perfiles/admin/functions.inc.php
 *
 */

/**
 * Valida los datos de un registro de idioma
 *
 * @param array $data
 * @return bool
 */
function perfiles_validarDatos($data)
{
	$ok = true;

	$requeridos = array(
		'nombre'=>'Nombre',
		);

	foreach($requeridos as $key=>$nombre)
	{
		if(!isset($data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key]) || $data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key] == '')
		{
			SWPHP::_Msg("Falta el dato: {$nombre} ({$swphp_idiomas[SWPHP_IDIOMA_POR_DEFECTO]['nombre']})", "error");
			$ok = false;
		}
	}

	return $ok;
}
/**
 * Prepara los datos para insertar o actualizar un perfil en la base de datos
 *
 * @param array $data
 * @param int $id
 * @return array
 */
function perfiles_prepararDatos($data, $id=0)
{
	global $db;

	foreach($data as $key=>$value)
	{
		switch($key)
		{
			default:
				//Cualquier otro dato lo descarto
				unset($data[$key]);
				break;
		}
	}

	return $data;
}
/**
 * Prepara los datos para insertar o actualizar datos de un perfil en idioma
 *
 * @param array $idiomas
 * @param int $idioma_id
 * @param int $id
 * @return array
 */
function perfiles_prepararDatosIdioma($idiomas, $idioma_id, $id=0)
{
	global $db;

	$data = SWPHP::_PrepararDatosIdioma($idiomas, $idioma_id, array('nombre'));

	if($id)
	{
		$data['perfil_id'] = $id;
	}
	$data['idioma_id'] = $idioma_id;

	return $data;
}
/**
 * Elimina un perfil
 *
 * @param int $id
 * @return bool
 */
function perfiles_eliminarPerfil($id)
{
	global $db;

	if($db->Exists($id, 'perfil_id', SWPHP_DBPREFIX.'users'))
	{
		SWPHP::_Msg('No se puede eliminar el perfil porque está en uso (hay usuarios con este perfil)', 'prohibido');

		return false;
	}

	if($db->Execute("DELETE FROM ".SWPHP_DBPREFIX."perfiles WHERE id = '{$id}'"))
	{
		$db->Execute("DELETE FROM ".SWPHP_DBPREFIX."perfiles_idiomas WHERE perfil_id = '{$id}'");

		return true;
	}

	return false;
}
?>