<h1><?php echo SWPHP_Install::l('Paso 3 - Configuración básica'); ?></h1>
<p><?php echo SWPHP_Install::l('Se ha comprobado si los datos introducidos son válidos, y en caso afirmativo se ha procedido a guardar la configuración, crear las tablas y rellenarlas con datos por defecto.'); ?></p>
<h3><?php echo SWPHP_Install::l('Resultado del proceso:'); ?></h3>
<?php
require_once(SWPHP_COMMON_DIR.'functions/sql.php');
require_once(SWPHP_COMMON_DIR.'classes/MyCache.class.php');
require_once(SWPHP_COMMON_DIR.'classes/DB_ResultSet.class.php');
require_once(SWPHP_COMMON_DIR.'classes/DB_Connection.class.php');
require_once(SWPHP_COMMON_DIR.'classes/SWPHP.class.php');

$data = SWPHP_Install::PrepararBasica($_POST);

$ok = false;

if(ValidarBasica($data))
{
	Msg(SWPHP_Install::l('Se han validado los datos introducidos'), 'check');

    SWPHP_Install::SetConfigConst($data);

	if(SWPHP_Install::SaveConfigConst())
	{
        Msg(SWPHP_Install::l('Se ha actualizado el contenido de')." <b>".SWPHP_Install::CONFIG_FILE."</b>", 'check');

        if(SWPHP_ADMIN_DIR != $data['admin_dir'])
        {
            if(!rename(SWPHP_ADMIN_DIR, $data['admin_dir']))
            {
                Msg(SWPHP_Install::l('No se ha podido renombrar la subcarpeta para administración'), 'error');
                Msg(SWPHP_Install::l('Cámbiale el nombre a mano:').' '.SWPHP_Install::l('de').' <b>'.SWPHP_ADMIN_DIR.'</b> '.SWPHP_Install::l('a').' <b>'.$data['admin_dir'].'</p>', 'info');
            }
        }

        $db = SWPHP_Install::GetDb();

		if($db)
        {
            $filepath = SWPHP_INSTALL_DIR."sql/kptltruth_2.0.0.sql";
            if(is_file($filepath))
            {
                if(ExecuteSQLFile($filepath, $data['droptable']))
                {
                    Msg(SWPHP_Install::l('Se ha procesado con éxito el archivo con las instrucciones SQL'), 'check');

                    if($data['predefinidas'])
                    {
                    	$filepath2 = SWPHP_INSTALL_DIR."sql/kptltruth_2.0.0_predefinidas.sql";
                    	if(is_file($filepath2))
                    	{
                    		ExecuteSQLFile($filepath2, $data['droptable']);
                    	}
                    	else
			            {
			                Msg(SWPHP_Install::l('No se encuentra el archivo con las categorías predefinidas')." <b>{$filepath2}</b>", 'error');
			                Msg(SWPHP_Install::l('No se han creado las categorías predefinidas'), 'aviso');
			            }
                    }

                    if(SWPHP_Install::SaveConfigValues($data))
                    {
                        Msg(SWPHP_Install::l('Se han actualizado los valores de la tabla de configuración'), 'check');

                        $idioma_id = $db->GetValueQuery("SELECT id FROM ".SWPHP_DBPREFIX."idiomas WHERE codigoiso = '{$lang}'", false);
                        if($idioma_id && SWPHP::_SetConfigValue('idioma', $idioma_id, 'idiomas'))
                        {
                            Msg(SWPHP_Install::l('Se ha establecido el idioma por defecto'), 'check');

                            $ok = true;
                        }
                        else
                        {
                            Msg(SWPHP_Install::l('No se ha podido establecer el idioma por defecto'), 'error');
                        }
                    }
                }
            }
            else
            {
                Msg(SWPHP_Install::l('No se encuentra el archivo con las instrucciones SQL')." <b>{$filepath}</b>", 'error');
                Msg(SWPHP_Install::l('Asegúrate de subir todos los archivos incluidos en').' '.SWPHP_Install::APP_NAME, 'info');
                Msg(SWPHP_Install::l('Se ha cancelado el proceso de creación de las tablas'), 'aviso');
            }
        }
	}
	else
	{
		Msg(SWPHP_Install::l('No se ha podido actualizar el contenido de')." <b>".SWPHP_Install::CONFIG_FILE."</b>", 'error');
		Msg(SWPHP_Install::l('Edita a mano el archivo')." <b>".SWPHP_Install::CONFIG_FILE."</b>", 'info');
		Msg(SWPHP_Install::l('Se ha cancelado el proceso de creación de las tablas'), 'aviso');
	}
}

if($ok)
{
	?>
	<br />
	<h2><?php echo SWPHP_Install::l('Administradores'); ?></h2>
	<p><?php echo SWPHP_Install::l('Es necesario establecer el usuario administrador del gestor de contenidos y los administradores de Kptl Truth.'); ?></p>
	<?php
	$data = array(
	    'nick'=>'admin',
	    'pass'=>'',
	    'cpass'=>'',
	    'email'=>'',
	    'tambien'=>'0',
	    'convertir'=>'0',
	    'nombre'=>'',
	    'fechanacimiento'=>'',
	    );

	echo GetFormAdministradores($data, 20);
}
else
{
    //TODO: info "ha habido algun problema"

    echo GetFormBasica($data, 10, 'Reintentar');
}
