<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-02-04
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * install/index.php
 *
 */

require('inc/classes/SWPHP_Install.class.php');

chdir('../');

if(is_file(SWPHP_Install::CONFIG_FILE) && is_readable(SWPHP_Install::CONFIG_FILE))
{
    include(SWPHP_Install::CONFIG_FILE);
}

SWPHP_Install::DefineConfigConst();

require_once(SWPHP_COMMON_DIR.'functions/internet.php');
require_once(SWPHP_COMMON_DIR.'functions/validations.php');

if(!defined('__DIR__'))
{
    define('__DIR__', dirname(__FILE__));
}

define('SWPHP_INSTALL_DIR', ponerBarra(__DIR__));
define('SWPHP_MODULES_DIR', SWPHP_INC_DIR.'modulos/');

$lang = isset($_GET["lang"]) && $_GET["lang"] ? $_GET["lang"] : "es";

$file = SWPHP_INSTALL_DIR.'lang/'.$lang.'/index.php';
if(is_file($file))
{
    include($file);
}

$pasoactual = isset($_GET["paso"]) ? intval($_GET["paso"]) : 0;
$pasos = array(
	array("label"=>SWPHP_Install::l("Info."), "href"=>"index.php?paso=0&lang=".$lang, "title"=>SWPHP_Install::l("Información sobre la instalación"), "enabled"=>$pasoactual>10),
	array("label"=>SWPHP_Install::l("P. 1"), "href"=>"index.php?paso=1&lang=".$lang, "title"=>SWPHP_Install::l("Paso 1 - Comprobación de requisitos"), "enabled"=>$pasoactual>11),
	array("label"=>SWPHP_Install::l("P. 2"), "href"=>"index.php?paso=2&lang=".$lang, "title"=>SWPHP_Install::l("Paso 2 - Conexión a la base de datos"), "enabled"=>$pasoactual>12),
	array("label"=>SWPHP_Install::l("P. 3"), "href"=>"index.php?paso=3&lang=".$lang, "title"=>SWPHP_Install::l("Paso 3 - Configuración básica"), "enabled"=>$pasoactual>13),
	array("label"=>SWPHP_Install::l("P. 4"), "href"=>"index.php?paso=4&lang=".$lang, "title"=>SWPHP_Install::l("Paso 4 - Administradores"), "enabled"=>$pasoactual>14),
	array("label"=>SWPHP_Install::l("P. 5"), "href"=>"index.php?paso=5&lang=".$lang, "title"=>SWPHP_Install::l("Paso 5 - Modo de ejecución del motor"), "enabled"=>$pasoactual>15),
	);

include(SWPHP_INSTALL_DIR.'inc/header.php');

echo "<div style=\"float:right;border:1px solid #c0c0c0;background:#f8f8f8\">".TablaProgreso($pasos, $pasoactual, false, 50, 10, "Progreso:")."</div>";

$filepaso = sprintf(SWPHP_INSTALL_DIR.'inc/paso%02s.php', $pasoactual);
if(is_file($filepaso))
{
	include($filepaso);
}

include(SWPHP_INSTALL_DIR.'inc/footer.php');


/* FUNCIONES */

function GetFormConexion($data, $margin=0, $accion="Continuar")
{
    global $lang;

	return sprintf('<form id="form_cms" action="index.php?paso=2&lang=%s" method="post" onsubmit="return validador.ValidarForm(this.id)">
		<table style="margin:%spx 0 %spx 0">
		<tr><th colspan="2">%s</th></tr>
		<tr><td>%s</td><td><input type="text" name="dbhost" value="%s" size="20" class="requerido" /></td></tr>
		<tr><td>%s</td><td><input type="text" name="dbport" value="%s" size="20" class="requerido numeric" /></td></tr>
		<tr><td>%s</td><td><input type="text" name="dbname" value="%s" size="20" class="requerido" /></td></tr>
		<tr><td>%s</td><td><input type="text" name="dbuser" value="%s" size="20" class="requerido" /></td></tr>
		<tr><td>%s</td><td><input type="password" name="dbpass" value="%s" size="20" /></td></tr>
		<tr><th colspan="2">%s</th></tr>
		<tr><td>%s</td><td><input type="text" name="dbprefix" value="%s" size="20" /><div class="mini">%s</div></td></tr>
		</table>
		<div style="text-align:center">
            <a href="javascript:submitForm();" class="continuar">%s</a>
		</div>
		</form>',
        $lang, $margin, $margin*2,
        SWPHP_Install::l('Datos de acceso a la base de datos'),
        SWPHP_Install::l('Servidor de base de datos'), $data["dbhost"],
        SWPHP_Install::l('Puerto para la conexión'), $data["dbport"],
        SWPHP_Install::l('Nombre de la base de datos'), $data["dbname"],
        SWPHP_Install::l('Usuario de la base de datos'), $data["dbuser"],
        SWPHP_Install::l('Contraseña de este usuario'), $data["dbpass"],
        SWPHP_Install::l('Personalización'),
        SWPHP_Install::l('Prefijo para las tablas'), $data["dbprefix"], SWPHP_Install::l('Utiliza un prefijo diferenciado si compartes la base de datos con otras aplicaciones u otra instalación de SWPHP EA.'),
        SWPHP_Install::l($accion)
        );
}

function GetFormBasica($data, $margin=0, $accion="Continuar")
{
    global $lang;

    return sprintf('<form id="form_cms" action="index.php?paso=3&lang=%s" method="post" onsubmit="return validador.ValidarForm(this.id)">
		<table style="margin:%spx 0 %spx 0">
		<tr><th colspan="2">%s</th></tr>
		<tr><td>%s</td><td><input type="text" name="organizacion" value="%s" size="60" /> <div class="mini">%s</div></td></tr>
		<tr><td>%s</td><td><input type="text" name="dominio" value="%s" size="60" /> <div class="mini">%s</div></td></tr>
		<tr><td>%s</td><td><input type="text" name="path" value="%s" size="60" /> <div class="mini">%s</div></td></tr>
		<tr><td>%s</td><td><input type="text" name="admin_dir" value="%s" size="20" class="requerido" /> <div class="mini">%s</div></td></tr>
		<tr><th colspan="2">%s</th></tr>
		<tr><td>%s</td><td><input type="text" name="emailenvios" value="%s" size="60" class="requerido email" /> <div class="mini">%s</div></td></tr>
		<tr><td>%s</td><td><input type="text" name="nombreenvios" value="%s" size="60" /> <div class="mini">%s</div></td></tr>
		<tr><td>%s</td><td><input type="radio" name="usar_smtp" id="usar_smtp_1" value="1" %s onclick="ActSMTP()" class="requerido" /><label for="usar_smtp_1"> %s</label> <input type="radio" name="usar_smtp" id="usar_smtp_0" value="0" %s onclick="ActSMTP()" /><label for="usar_smtp_0"> %s</label> <div class="mini">%s</div></td></tr>
        <tr class="smtp" style="display:none"><td>%s</td><td><input type="text" name="smtp_user" value="%s" size="30" /></td></tr>
		<tr class="smtp" style="display:none"><td>%s</td><td><input type="password" name="smtp_pass" value="%s" size="30" /></td></tr>
		<tr class="smtp" style="display:none"><td>%s</td><td><input type="text" name="smtp_host" value="%s" size="30" /></td></tr>
		<tr class="smtp" style="display:none"><td>%s</td><td><input type="text" name="smtp_port" value="%s" size="30" class="numeric" /> <div class="mini">%s</div></td></tr>
		<tr><th colspan="2">Kptl Truth</th></tr>
		<tr><td>%s</td><td>%s <input type="text" name="KPTL_punto" id="KPTL_punto" value="%s" size="20" maxlength="40" class="requerido" onkeyup="ActPunto()" /> %s <input type="text" name="KPTL_puntos" id="KPTL_puntos" value="%s" size="20" maxlength="40" class="requerido" onkeyup="ActPunto()" /> <div class="mini">%s "%s <span id="ej_el"></span>", "%s <span id="ej_un"></span>", "%s <span id="ej_varios"></span>"</div></td></tr>
        <tr><td>%s</td><td><select name="kptl_config[potencia]" id="kptl_potencia" onchange="gebi(\'puntos\').innerHTML = Math.pow(10,this.value)" class="requerido"><option value="2" %s>2</option><option value="3" %s>3</option><option value="4" %s>4</option><option value="5" %s>5</option><option value="6" %s>6</option></select> (<span id="ej_puntos"></span> %s <span id="puntos">%s</span>)</td></tr>
        <tr><th colspan="2">%s</th></tr>
		<tr><td>%s</td><td><input type="radio" name="droptable" id="droptable_1" value="1" %s class="requerido" /><label for="droptable_1"> %s</label> <input type="radio" name="droptable" id="droptable_0" value="0" %s /><label for="droptable_0"> %s</label> <div class="mini">%s</div></td></tr>
		<tr><td>%s</td><td><input type="radio" name="predefinidas" id="predefinidas_1" value="1" %s class="requerido" /><label for="predefinidas_1"> %s</label> <input type="radio" name="predefinidas" id="predefinidas_0" value="0" %s /><label for="predefinidas_0"> %s</label> <div class="mini">%s</div></td></tr>
        </table>
		<div style="text-align:center">
            <a href="javascript:submitForm();" class="continuar">%s</a>
		</div>
		</form>
        <script type="text/javascript">
        function ActSMTP(){
            if(gebi(\'usar_smtp_1\').checked){
                $(\'tr.smtp\').show(1000);
            }
            else{
                $(\'tr.smtp\').hide(1000);
            }
        }
        function ActPunto(){
            gebi(\'ej_el\').innerHTML = gebi(\'KPTL_punto\').value;
            gebi(\'ej_un\').innerHTML = gebi(\'KPTL_punto\').value;
            gebi(\'ej_varios\').innerHTML = gebi(\'KPTL_puntos\').value;
            gebi(\'ej_puntos\').innerHTML = gebi(\'KPTL_puntos\').value;
        }

        ActSMTP();
        ActPunto();
        </script>',
        $lang, $margin, $margin*2,
        SWPHP_Install::l('General'),
        SWPHP_Install::l('Organización'), $data["organizacion"], SWPHP_Install::l('Nombre de la entidad para la que se instala el sistema'),
        SWPHP_Install::l('Dominio'), $data["dominio"], SWPHP_Install::l('Dominio principal, sin http'),
        SWPHP_Install::l('Ruta dentro del dominio'), $data["path"], SWPHP_Install::l('Indícala si instalas el sistema en una subcarpeta dentro del raiz del dominio'),
        SWPHP_Install::l('Subcarpeta para administración'), quitarBarra($data["admin_dir"]), SWPHP_Install::l('Puedes llamarla admin, pero si le das un nombre personalizado tu página ganará en seguridad.'),
        SWPHP_Install::l('Email'),
        SWPHP_Install::l('Email envíos'), $data["emailenvios"], SWPHP_Install::l('Dirección remitente de los emails del sistema'),
        SWPHP_Install::l('Nombre envíos'), $data["nombreenvios"], SWPHP_Install::l('Nombre remitente de los emails del sistema'),
        SWPHP_Install::l('Usar SMTP'), $data["usar_smtp"] ? 'checked="checked"' : '', SWPHP_Install::l('Sí'), $data["usar_smtp"] ? '' : 'checked="checked"', SWPHP_Install::l('No'), SWPHP_Install::l('Utiliza SMTP si la configuración por defecto de tu servidor no es válida para realizar envíos'),
        SWPHP_Install::l('Usuario SMTP'), $data["smtp_user"],
        SWPHP_Install::l('Contraseña SMTP'), $data["smtp_pass"],
        SWPHP_Install::l('Servidor SMTP'), $data["smtp_host"],
        SWPHP_Install::l('Puerto SMTP'), $data["smtp_port"], SWPHP_Install::l('Deja el puerto en blanco si no lo sabes'),
        SWPHP_Install::l('Nombre de la moneda'), SWPHP_Install::l('singular'), $data["kptl_config"]["KPTL_punto"], SWPHP_Install::l('plural'), $data["kptl_config"]["KPTL_puntos"], SWPHP_Install::l('La moneda tiene género masculino.').' '.SWPHP_Install::l('Ejemplos de uso:'), SWPHP_Install::l('el'), SWPHP_Install::l('un'), SWPHP_Install::l('varios'),
        SWPHP_Install::l('Potencia Kptl'), $data["kptl_config"]["potencia"] == 2 ? 'selected="selected"' : '', $data["kptl_config"]["potencia"] == 3 ? 'selected="selected"' : '', $data["kptl_config"]["potencia"] == 4 ? 'selected="selected"' : '', $data["kptl_config"]["potencia"] == 5 ? 'selected="selected"' : '', $data["kptl_config"]["potencia"] == 6 ? 'selected="selected"' : '', SWPHP_Install::l('en el tesoro'), pow(10, $data["kptl_config"]["potencia"]),
        SWPHP_Install::l('Opciones'),
        SWPHP_Install::l('Eliminar tablas'), $data["droptable"] ? 'checked="checked"' : '', SWPHP_Install::l('Sí'), $data["droptable"] ? '' : 'checked="checked"', SWPHP_Install::l('No'), SWPHP_Install::l('Eliminar las tablas si existen antes de crearlas (haz antes una copia de seguridad)'),
        SWPHP_Install::l('Categorías predefinidas'), $data["predefinidas"] ? 'checked="checked"' : '', SWPHP_Install::l('Sí'), $data["predefinidas"] ? '' : 'checked="checked"', SWPHP_Install::l('No'), SWPHP_Install::l('Crear categorías de preguntas predefinidas (pueden cambiarse posteriormente) o empezar en blanco'),
        SWPHP_Install::l($accion)
        );
}

function GetFormAdministradores($data, $margin=0, $accion="Continuar")
{
    global $lang;

	return sprintf('<form id="form_cms" action="index.php?paso=4&lang=%s" method="post" onsubmit="return validador.ValidarForm(this.id)">
		<table style="margin:%spx 0 %spx 0">
		<tr><th colspan="2">%s</th></tr>
		<tr><td>%s</td><td><input type="text" name="nick" value="%s" size="30" class="requerido" /> <div class="mini">%s</div></td></tr>
		<tr><td>%s</td><td><input type="password" name="pass" value="%s" size="30" class="requerido" /> <div class="mini">%s '.SWPHP_PASSWORD_MINLENGTH.' %s '.SWPHP_PASSWORD_MAXLENGTH.' %s</div></td></tr>
		<tr><td>%s</td><td><input type="password" name="cpass" value="%s" size="30" /></td></tr>
		<tr><td>%s</td><td><input type="text" name="email" value="%s" size="30" class="email requerido" /></td></tr>
        <tr><td>%s</td><td><input type="radio" name="tambien" id="tambien_1" value="1" %s class="requerido" onclick="UpdMinAdmin()" /><label for="tambien_1"> %s</label> <input type="radio" name="tambien" id="tambien_0" value="0" %s onclick="UpdMinAdmin()" /><label for="tambien_0"> %s</label>
		<tr><td>%s</td><td><input type="radio" name="convertir" id="convertir_1" value="1" %s class="requerido" onclick="ActConv(\'convertir_1\', \'convertir\')" /><label for="convertir_1"> %s</label> <input type="radio" name="convertir" id="convertir_0" value="0" %s onclick="ActConv(\'convertir_1\', \'convertir\')" /><label for="convertir_0"> %s</label>
		<tr class="convertir" style="display:none"><td>%s</td><td><input type="text" name="nombre" id="nombre" value="%s" size="30" class="" /> <div class="mini">%s</div></td></tr>
		<tr class="convertir" style="display:none"><td>%s</td><td><input type="text" name="fechanacimiento" value="%s" size="20" maxlength="10" class="date" /> <span class="mini">(%s)</span> <div class="mini">%s</div></td></tr>
		<tr><th colspan="2">%s</th></tr>
        <tr><td colspan="2"><div id="div_adminsKptl"></div></td></tr>
        <tr><td colspan="2"><img src="img/icons/16x16/add.png" alt="Add" /> <a href="javascript:AddAdminKptl();">%s</a></td></tr>
        <tr id="tr_minadmin" style="display:none"><td>%s</td><td><input type="text" name="minadmin" id="minadmin" value="1" class="numeric requerido minvalue1 maxvalue1" size="5" maxlength="3" /> <div class="mini">%s</div></td></tr>
		</table>
		<div style="text-align:center">
            <a href="javascript:submitForm();" class="continuar">%s</a>
		</div>
		</form>
        <div id="div_copyFrom" style="display:none">
            <table class="underline">
            <tr><td>%s</td><td><input type="text" name="adminsKptl[numAdminKptl][nick]" id="adminsKptl_numAdminKptl_nick" value="" size="30" class="requerido" /></td></tr>
            <tr><td>%s</td><td><input type="password" name="adminsKptl[numAdminKptl][pass]" value="" size="30" class="requerido" /> <div class="mini">%s '.SWPHP_PASSWORD_MINLENGTH.' %s '.SWPHP_PASSWORD_MAXLENGTH.' %s</div></td></tr>
            <tr><td>%s</td><td><input type="password" name="adminsKptl[numAdminKptl][cpass]" value="" size="30" /></td></tr>
            <tr><td>%s</td><td><input type="text" name="adminsKptl[numAdminKptl][email]" value="" size="30" class="email requerido" /></td></tr>
            <tr><td>%s</td><td><input type="radio" name="adminsKptl[numAdminKptl][tambien]" id="adminsKptl_numAdminKptl_tambien_1" value="1" class="requerido" /><label for="adminsKptl_numAdminKptl_tambien_1"> %s</label> <input type="radio" name="adminsKptl[numAdminKptl][tambien]" id="adminsKptl_numAdminKptl_tambien_0" value="0" checked="checked" /><label for="adminsKptl_numAdminKptl_tambien_0"> %s</label>
            <tr><td>%s</td><td><input type="radio" name="adminsKptl[numAdminKptl][convertir]" id="adminsKptl_numAdminKptl_convertir_1" value="1" class="requerido" onclick="ActConv(\'adminsKptl_numAdminKptl_convertir_1\', \'convertir_numAdminKptl\')" /><label for="adminsKptl_numAdminKptl_convertir_1"> %s</label> <input type="radio" name="adminsKptl[numAdminKptl][convertir]" id="adminsKptl_numAdminKptl_convertir_0" value="0" onclick="ActConv(\'adminsKptl_numAdminKptl_convertir_1\', \'convertir_numAdminKptl\')" /><label for="adminsKptl_numAdminKptl_convertir_0"> %s</label>
            <tr class="convertir_numAdminKptl" style="display:none"><td>%s</td><td><input type="text" name="adminsKptl[numAdminKptl][nombre]" id="adminsKptl_numAdminKptl_nombre" value="" size="30" class="" /> <div class="mini">%s</div></td></tr>
            <tr class="convertir_numAdminKptl" style="display:none"><td>%s</td><td><input type="text" name="adminsKptl[numAdminKptl][fechanacimiento]" value="" size="20" maxlength="10" class="date" /> <span class="mini">(%s)</span> <div class="mini">%s</div></td></tr>
            </table>
        </div>
        <script type="text/javascript">
        var numAdminGestor = 1;
        var numAdminKptl = 0;

        function AddAdminKptl(){
            numAdminKptl++;

            var div = document.createElement(\'div\');
            div.innerHTML = gebi(\'div_copyFrom\').innerHTML.replace(/numAdminKptl/g, numAdminKptl);
            gebi(\'div_adminsKptl\').appendChild(div);
            gebi(\'adminsKptl_\'+numAdminKptl+\'_nick\').focus();
            UpdMinAdmin();
        }
        function GetTotalAdminKptl(){
            return gebi(\'tambien_1\').checked ? numAdminKptl+1 : numAdminKptl;
        }
        function UpdMinAdmin(){
            var totalAdminKptl = GetTotalAdminKptl();
            if(totalAdminKptl > 1){
                $(\'#tr_minadmin\').show(1000);
            }
            gebi(\'minadmin\').className = \'numeric requerido minvalue1 maxvalue\'+totalAdminKptl;
        }
        function ActConv(id, className){
            if(gebi(id).checked){
                $(\'tr.\'+className).show(1000);
                gebi(id.replace(\'convertir_1\',\'nombre\')).className = \'requerido\';
            }
            else{
                $(\'tr.\'+className).hide(1000);
                gebi(id.replace(\'convertir_1\',\'nombre\')).className = \'\';
            }
        }
        </script>',
        $lang, $margin, $margin*2,
        SWPHP_Install::l('Administrador del gestor de contenidos'),
        SWPHP_Install::l('Nombre de usuario'), $data["nick"], SWPHP_Install::l('Alias de usuario unívoco, puede ser admin, pero si lo personalizas ganarás en seguridad.'),
        SWPHP_Install::l('Contraseña'), $data["pass"], SWPHP_Install::l('De'), SWPHP_Install::l('a'), SWPHP_Install::l('caracteres, no utilices palabras ni fechas, y utiliza tanto letras como dígitos.'),
        SWPHP_Install::l('Confirmar contraseña'), $data["cpass"],
        SWPHP_Install::l('Email'), $data["email"],
        SWPHP_Install::l('También es admin Kptl'), $data['tambien'] ? 'checked="checked"' : '', SWPHP_Install::l('Sí'), $data['tambien'] ? '' : 'checked="checked"', SWPHP_Install::l('No'),
        SWPHP_Install::l('Convertir en usuario Kptl'), $data['convertir'] ? 'checked="checked"' : '', SWPHP_Install::l('Sí'), $data['convertir'] ? '' : 'checked="checked"', SWPHP_Install::l('No'),
        SWPHP_Install::l('Nombre real'), $data["nombre"], SWPHP_Install::l('Nombre real completo, es necesario para que los demás usuarios lo identifiquen dentro de Kptl.'),
        SWPHP_Install::l('Fecha de nacimiento'), $data["fechanacimiento"], SWPHP_Install::l('dd/mm/aaaa'), SWPHP_Install::l('Opcional, no es un dato público, sólo se usa para estadísticas.'),
        SWPHP_Install::l('Administradores de Kptl'),
        SWPHP_Install::l('Añadir administrador'),
        SWPHP_Install::l('Administradores requeridos'), SWPHP_Install::l('Cuántos administradores de Kptl son necesarios para realizar una operación.'),
        SWPHP_Install::l($accion),
        SWPHP_Install::l('Nombre de usuario'),
        SWPHP_Install::l('Contraseña'), SWPHP_Install::l('De'), SWPHP_Install::l('a'), SWPHP_Install::l('caracteres, no utilices palabras ni fechas, y utiliza tanto letras como dígitos.'),
        SWPHP_Install::l('Confirmar contraseña'),
        SWPHP_Install::l('Email'),
        SWPHP_Install::l('También es admin gestor'), SWPHP_Install::l('Sí'), SWPHP_Install::l('No'),
        SWPHP_Install::l('Convertir en usuario Kptl'), SWPHP_Install::l('Sí'), SWPHP_Install::l('No'),
        SWPHP_Install::l('Nombre real'), SWPHP_Install::l('Nombre real completo, es necesario para que los demás usuarios lo identifiquen dentro de Kptl.'),
        SWPHP_Install::l('Fecha de nacimiento'), SWPHP_Install::l('dd/mm/aaaa'), SWPHP_Install::l('Opcional, no es un dato público, sólo se usa para estadísticas.')
        );
}

function GetFormEjecucionMotor($data, $margin=0, $accion="Finalizar")
{
    global $lang;

	return sprintf('<form id="form_cms" action="index.php?paso=5&lang=%s" method="post" onsubmit="return validador.ValidarForm(this.id)">
		<table style="margin:%spx 0 %spx 0">
		<tr><th colspan="2">%s</th></tr>
		<tr><td>%s</td><td><select name="modomotor" id="modomotor" onchange="ModoMotor(this.value)"><option value="cron" %s>%s</option><option value="visitas" %s>%s</option></select></td></tr>
		<tr class="tr_cron" %s><td>%s</td><td><input type="text" name="croncode" id="croncode" value="%s" size="20" maxlength="32" onkeyup="gebi(\'span_croncode\').innerHTML = this.value" /></td></tr>
		<tr class="tr_cron" %s><td>%s</td><td>%s</td></tr>
		</table>
		<div style="text-align:center">
            <a href="javascript:submitForm();" class="continuar">%s</a>
		</div>
		</form>
		<script type="text/javascript">
        function ModoMotor(str){
            if(str == \'cron\'){
                $(\'.tr_cron\').show(1000);
            }
            else{
                $(\'.tr_cron\').hide(1000);
            }
        }
        </script>',
        $lang, $margin, $margin*2,
        SWPHP_Install::l('Modo de ejecución del motor de reparto'),
        SWPHP_Install::l('Lanzar el proceso por medio de'), $data['modomotor'] == 'cron' ? 'selected="selected"' : '', SWPHP_Install::l('cron'), $data['modomotor'] == 'visitas' ? 'selected="selected"' : '', SWPHP_Install::l('visitas'),
        $data['modomotor'] != 'cron' ? 'style="display:none"' : '', SWPHP_Install::l('Código para ejecutar el cron'), addcslashes($data['croncode'], "'"),
        $data['modomotor'] != 'cron' ? 'style="display:none"' : '', SWPHP_Install::l('URL del cron'), 'http://'.($_SERVER['HTTP_HOST'] ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME']).'/cron/kptl_diario.php?c=<span id="span_croncode">'.$data['croncode'].'</span>',
        SWPHP_Install::l($accion)
        );
}

function ValidarBasica($data)
{
    $ok = true;
    /*
    //url
	$url = $data["url"];
	if(substr($url,0,4) != "http" || strlen($url) < 5)
	{
		Msg(SWPHP_Install::l('La dirección URL no parece válida')." <b>{$url}</b>", 'error');
        $ok = false;
	}
    */
    //admin_dir
	if(!validateString(quitarBarra($data["admin_dir"]), 1, 100, 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWYZ1234567890-_.'))
	{
		Msg(SWPHP_Install::l('El nombre de la subcarpeta para administración no es válido'), 'error');
        $ok = false;
	}

	//emailenvios
	if(!validateEmail($data["emailenvios"]))
	{
		Msg(SWPHP_Install::l('El email remitente de envíos del sistema no es válido'), 'error');
        $ok = false;
    }

	return $ok;
}

function ValidarAdmin($data)
{
    $ok = true;

    //nick admin
	if(!validateString($data["nick"], SWPHP_NICK_MINLENGTH, SWPHP_NICK_MAXLENGTH, SWPHP_NICK_VALIDCHARS))
	{
		Msg(SWPHP_Install::l('El nombre de usuario del administrador no es válido'), 'error');
        $ok = false;
	}

	//pass admin
	if(!validateString($data["pass"], SWPHP_PASSWORD_MINLENGTH, SWPHP_PASSWORD_MAXLENGTH, SWPHP_PASSWORD_VALIDCHARS))
	{
		Msg(SWPHP_Install::l('La contraseña para el administrador no es válida'), 'error');
        $ok = false;
	}
	elseif($data["pass"] != $data["cpass"])
	{
		Msg(SWPHP_Install::l('La contraseña no se ha confirmado correctamente'), 'error');
        $ok = false;
	}

	//email
	if(!validateEmail($data["email"]))
	{
		Msg(SWPHP_Install::l('El email del usuario administrador no es válido'), 'error');
        $ok = false;
    }

	return $ok;
}

function ExecuteSQLFile($filepath, $droptable=false)
{
    global $db;

	$ok = true;
    $query = "";
	$fp = fopen($filepath, "r");
	$c = 0;
	while(!feof($fp) && $c < 100000)
	{
		$c++;
		$str = fgets($fp);
		if($str[0] != "#")
		{
			$query .= $str;
		}
		$aux = rtrim($str);
		if($aux && $aux[strlen($aux)-1] == ";")
		{
			$query = trim(str_replace(
				array("DROP TABLE IF EXISTS `swphp_", "CREATE TABLE IF NOT EXISTS `swphp_", "INSERT INTO `swphp_", "UPDATE `swphp_"),
				array("DROP TABLE IF EXISTS `".SWPHP_DBPREFIX, "CREATE TABLE IF NOT EXISTS `".SWPHP_DBPREFIX, "INSERT INTO `".SWPHP_DBPREFIX, "UPDATE `".SWPHP_DBPREFIX),
				$query
				));
			if($droptable || strtoupper(substr($query, 0, 11)) != "DROP TABLE ")
			{
                if(!$db->Execute($query))
				{
					Msg(SWPHP_Install::l('Error ejecutando sentencia SQL')."<br />".SWPHP::_HtmlEntities($query).'<br />'.$db->Error(), 'error');
                    $ok = false;
				}
			}
			$query = "";
		}
	}
	fclose($fp);

    return $ok;
}

function ExecuteQueryAndGetMsg($query, $okmsg, $errmsg, $link)
{
	if(@mysql_query($query, $link))
	{
		Msg($okmsg, 'check');
        return true;
	}

    Msg(str_replace("[*error*]", mysql_error(), $errmsg), 'error');
    return false;
}

function TablaProgreso($pasos=array(), $pasoactual=0, $shorturl=false, $cellwidth=30, $cellheight=7, $etiqueta="")
{
	$html = "<table cellpadding=\"1\" cellspacing=\"1\" border=\"0\"><tr>";

	if($etiqueta)
	{
		$html .= sprintf("<td rowspan=\"2\" style=\"vertical-align:middle\"><b>%s</b>&nbsp;&nbsp;&nbsp;</td>", $etiqueta);
	}

	foreach($pasos as $paso)
	{
		$html .= sprintf("<td title=\"%s\" class=\"mini", $paso["title"]);
		if($paso["enabled"])
		{
			$html .= sprintf(" cursor_pointer\" onclick=\"window.location = '%s'", UrlFormat($paso["href"], $shorturl));
		}
		$html .= sprintf("\" style=\"text-align:center\">%s</td>", $paso["label"]);
	}

	$html .= sprintf("</tr><tr style=\"height:%spx\">", $cellheight);

	$c = 0;
	foreach($pasos as $paso)
	{
		$html .= sprintf("<td title=\"%s\" style=\"width:%spx;background:", $paso["title"], $cellwidth);

		if($c < $pasoactual)
		{
			$html .= "#00FF00\"";
			if($paso["enabled"])
			{
				$html .= sprintf("#00FF00\" class=\"cursor_pointer\" onclick=\"window.location = '%s'\"", UrlFormat($paso["href"], $shorturl));
			}
		}
		elseif($c == $pasoactual)
		{
			$html .= "#FFFF00\"";
			if($paso["enabled"])
			{
				$html .= sprintf("#00FF00\" class=\"cursor_pointer\" onclick=\"window.location = '%s'\"", UrlFormat($paso["href"], $shorturl));
			}
		}
		else
		{
			if($paso["enabled"])
			{
				$html .= sprintf("#FF8800\" class=\"cursor_pointer\" onclick=\"window.location = '%s'\"", UrlFormat($paso["href"], $shorturl));
			}
			else
			{
				$html .= "#FF0000\"";
			}
		}

		$html .= "></td>";

		$c++;
	}

	return $html."</tr></table>";
}

function Msg($texto, $clase='info')
{
    echo "<div class=\"{$clase}\">{$texto}</div>\n";
    flush();
}
?>